//  Tratamiento de caracteres, comportamiento
//  Tymoschuk, Torge
# include <iostream.h>
class Caracter{
private:          // Parte interna de la clase
	char car;   	// Nuestro caracter
	int cLetras;   // Contador de letras
	int cLetMin;   // Minusculas
	int cLetMay;   // Mayusculas
	int cVocal;    // Vocales
	int cConso;    // Consonantes
	int cDigDec;   // Dgitos decimales
	int cDigHex;   // Dgitos hexadec.
	int cSigPun;   // Signos de puntuacion
	int esLetra(); 	// Retorna 1 minscula, 2 mayscula, 0 no es letra
	int esVocal(); 	// Retorna 1 si vocal, 0 no es vocal
	int esConso(); 	// Retorna 1 si consonante, 0 si no es
	int esLetMay();	// Retorna 1 si es letra mayuscula
	int esLetMin();	// Retorna 1 si es letra minscula
	int esDigDec();	// Retorna 1 si es dgito decimal
	int esDigHex();	// Retorna 1 si es dgito hexadecimal
	int esSigPun();	// Retorna 1 si es signo puntuacin
public:              // Parte publica, interface con el usuario: main()   
	Caracter();       // Constructor
	char leeCar();  	// Inicializa car mediante lectura y lo retorna
	void setCar(char car);	//  Inicializa car mediante parmetro
	char getCar();		// Retorna car
	int  finDatos();	// Retorna 1 si se digita #
	void cuenta();    // Contabiliza los distintos tipos
	void toString();  // Exhibe resultados
};

Caracter::Caracter(){  // Constructor
	car=' ';
	cLetras=cLetMin=cLetMay=cVocal=cConso=cDigDec=cDigHex=cSigPun=0;
	cout << "Introduzca caracteres, fin: # \n";
}

char Caracter::leeCar(){ // Todo lo digitado se almacena en buffer del teclado
	car=cin.get(); // pareciendo en pantalla. Al <Enter> se produce la primera
	return car;    // lectura, y se necesita de un ciclo para las siguientes.
}         		 // Cada caracter leido es almacenado en car y tambien retornado

void Caracter::setCar(char cara){
	car = cara;            //  Inicializamos el atributo car
}

char Caracter::getCar(){
	return car;            //  Retornamos el atributo car.
}

int Caracter::esLetra(){
	int letra=0;
	if(esLetMay()) letra=1;
	if(esLetMin()) letra=1;
	return letra;                 //  Retornemos lo que haya sido
} //  Fin de la funcin

int Caracter::esVocal(){
	int vocal=0;		// Inicialmente suponemos que no es vocal
	char voca[10]="aeiouAEIOU";
	for(int i=0;i <= sizeof(voca);i++)
		if(voca[i]==car) vocal=1;  //  Es una vocal
	return vocal;                 //  Retornamos lo que sea ...
}

int Caracter::esConso(){
	int conso=0;
	if(esLetra() && !esVocal()) conso=1;
	return conso;
}

int Caracter::esLetMay(){
	int letra=0;     //  Inicialmente suponemos que no es letra minuscula
	char mayu[26]="ABCDEFGHIJKLMNOPQRSTUVWXYZ";
	for(int i=0;i <= sizeof(mayu);i++)
		if(mayu[i]==car) letra=1;  //  Es una letra mayscula
	return letra;
}

int Caracter::esLetMin(){
int letra=0;
	char minu[26]="abcdefghijklmnopqrstuvwxyz";
	for(int i=0;i < sizeof(minu);i++)
		if(minu[i]==car) letra=1;  //  Es una letra minscula
	return letra;
}

int Caracter::esDigDec(){
	int digDec=0;
	char dig10[10]="1234567890";
	for(int i=0;i <= sizeof(dig10);i++)
		if(dig10[i]==car) digDec=1;
	return digDec;
}

int Caracter::esDigHex(){
	int digHex=0;
	char dig16[16]="1234567890ABCDEF";
	for(int i=0;i <= sizeof(dig16);i++)
		if(dig16[i]==car) digHex=1;
	return digHex;
}


int Caracter::esSigPun(){
int sigPun=0;
	char punct[04]=".,;:";
	for(int i=0;i <= sizeof(punct);i++)
		if(punct[i]==car) sigPun=1;
	return sigPun;
}

int Caracter::finDatos(){
	int finDat=0;
	if(car=='#') finDat=1;
	return finDat;
}

void Caracter::cuenta(){
		if(esLetra()) cLetras++;
		if(esLetMin())cLetMin++;
		if(esLetMay())cLetMay++;
		if(esVocal ())cVocal ++;
		if(esConso ())cConso ++;
		if(esDigDec())cDigDec++;
		if(esDigHex())cDigHex++;
		if(esSigPun())cSigPun++;
}

void Caracter::toString(){
	cout << " Totales =\n";
	cout << "cLetras: "<< cLetras << " \n";
	cout << "cLetMin: "<< cLetMin << " \n";
	cout << "cLetMay: "<< cLetMay << " \n";
	cout << "cVocal : "<< cVocal  << " \n";
	cout << "cConso : "<< cConso  << " \n";
	cout << "cDigDec: "<< cDigDec << " \n";
	cout << "cDigHex: "<< cDigHex << " \n";
	cout << "cSigPun: "<< cSigPun << " \n";
	cout << "Terminado !!!\n";
}
